unit util;

interface

uses sysutils,classes,Controls,Forms,DB, ADODB,variants,clipbrd,strutils;

var g_Connect:TADOConnection;

//Nsrন StringList(H ssep ̾)
function StrToList(s: string; sSep: string=';'; lSort: boolean=True): TStringList;
//NStringListrন String(H ssep ̾)// this will Free Stringlist
function ListToStr(l: TStringList;sSep: string=';'): string;
//oField,YL(ť,NULL),h쫬A]ww]
function SetVarValue(Field: TField): variant;
function GetToken(seperators: string;var s: string): string;
function VarStr(const varPar: variant): string;
function GetToken2(InStr:String;Space:char;var pos:integer;var OutStr:String):Boolean;

function ADOSQLOpen(Qry:TADOQuery;const sSQL: string;connect:TADOConnection=nil):boolean;
function ADOSQLCreate(const sSQL: string;connect:TADOConnection=nil): TADOQuery;
function ADOSQLExec(const sSQL: string;connect:TADOConnection=nil):integer;
function ADOGetValue(sSql:string;var v: variant;lKeepValueNull:boolean=False;connect:TADOConnection=nil):Boolean;overload;
function ADOGetValue(sSql:string):variant;overload;

function AddSlash(s:string):string;

implementation

function StrToList(s: string; sSep: string=';'; lSort: boolean=True): TStringList;
begin
  Result := TStringList.Create;
  try
    Result.Sorted := lSort;
    Result.Text := AnsiReplaceStr(s, sSep, #13+#10);
  except
    Result.Free;
  end;
end;

function ListToStr(l: TStringList;sSep: string=';'): string;  // this will Free Stringlist
var s: string;
begin
  if l <> nil then begin
    s := l.Text;
    Result := AnsiReplaceStr(s, #13+#10, ssep);
  end;
end;

function SetVarValue(Field: TField): variant;
begin
  result := Field.Value;
  if ((Vartype(Result) = varEmpty) or (VarType(result) = VarNull)) then
    case Field.DataType of
      ftBoolean: Result := False;
      ftmemo,ftString,ftWideString: Result := '';
      ftFloat,ftBCD:Result := 0.0;
      ftSmallint, ftInteger: Result := 0;
      ftDate, ftDateTime: Result := 0.0;
    end;
end;

function ADOSQLOpen(Qry:TADOQuery;const sSQL: string;connect:TADOConnection=nil):boolean;
var ss: string;
begin
  Result := False;
  Screen.Cursor := crHourglass;
  qry.close;
  qry.sql.Clear;
  
  if Connect <> nil then
    qry.Connection:=Connect
  else if qry.Connection <> nil then  
  else if g_connect <> nil then
    qry.Connection:=g_Connect
  else
    Raise Exception.create('LConnetion ');

  qry.sql.Add(ssql);
  try
    qry.Open;
    if not qry.eof then
      Result:=True;
  except
    Clipboard.AsText := sSQL;
    raise;
  end;
  Screen.Cursor := crDefault;
end;

function ADOSQLCreate(const sSQL: string;connect:TADOConnection=nil): TADOQuery;
begin
  Result:=TADOQuery.Create(application.mainform);
  try
    if Connect <> nil then
      Result.Connection:=Connect
    else if g_connect <> nil then
      Result.Connection:=g_Connect
    else
      Raise Exception.create('LConnetion ');
    Result.sql.Add(ssql);
    Result.Open;
  Except
    Clipboard.AsText := sSQL;
    Result.free;
    raise;
  end;
end;

function ADOSQLExec(const sSQL: string;connect:TADOConnection=nil):integer;
var qry:TADOQuery;
begin
  Result:=0;
  qry:=TADOQuery.create(application.mainform);
  try
    if Connect <> nil then
      qry.Connection:=Connect
    else if g_connect <> nil then
      qry.Connection:=g_Connect
    else
      Raise Exception.create('LConnetion ');
    qry.sql.Add(ssql);
    Result:=qry.ExecSQL;
  Except
    Clipboard.AsText := sSQL;
    raise;
  end;
end;

function ADOGetValue(sSql:string;var v: variant;lKeepValueNull:boolean=False;connect:TADOConnection=nil):Boolean;
//get values from sql String
//Note:1. Return valueNO_EOF
//     2. lkeepvalueVull=false, L׬O_,convertҶtype,Ҧpinteger0
// EofɶǦ^False, v is VarEmpty
// not Eof Ȭ null,Ǧ^ȬTrue, v is VarNull
var Qry: TADOQuery;
    i: integer;
begin
  Result := False;
  qry:=ADOSQLCreate(ssql,connect);
  try
    try
      if Qry.Eof then
        v := unassigned
      else begin
        if Qry.FieldCount=1 then begin
          if lKeepValueNull then
            v := Qry.Fields[0].value
          else
            v := SetVarValue(Qry.Fields[0]);
        end
        else begin
          v := VarArrayCreate([0, Qry.FieldCount-1], varVariant);
          for i := 0 to Qry.FieldCount-1 do begin
            if lKeepValueNull then
              v[i] := Qry.Fields[i].value
            else
              v[i] := SetVarValue(Qry.Fields[i]);
          end;
        end;
      end;
      if Vartype(v) <> varEmpty then
        Result := True;
    except
      Clipboard.AsText := sSQL;
      raise;
    end;
  finally
    Qry.Free;
  end;
end;

function ADOGetValue(sSql:string):variant;
//OҤ@w
begin
  ADOGetValue(sSql,Result);
end;
function GetToken2(InStr:String;Space:char;var pos:integer;var OutStr:String):Boolean;
var ok:boolean;
begin
   ok:=false;
   OutStr:='';
   if pos<=length(InStr) then
   begin
      if pos<=length(InStr) then
      begin
         while (InStr[pos]=space) and (pos<=length(InStr)) do
            pos:=pos+1;
         while (InStr[pos]<>space) and (pos<=length(InStr)) do
         begin
            OutStr:=OutStr+InStr[pos];
            pos:=pos+1;
            ok:=true;
         end;
         if pos<=length(InStr) then
         if InStr[pos]=space then
         begin
            pos:=pos+1;
            ok:=true;
         end;
      end;
   end;
   GetToken2:=ok;
end;

//**************************************************************
//     ƦW: GetToken
//     ت: Io s tseperatorseq
//     : s := 'f1;f2;f3';
//         s1 := GetToken(';', s);
//         G s1='f1'.  s := 'f2;f3';
//**************************************************************
function GetToken(seperators: string;var s: string): string;
// get First token out of string s, return the token
var n,n1,n2:integer;
    c:char;
    s1: string;
begin
  s := TrimLeft(s);
  n := 1;n1 := 1;n2 := 1;
  while n<=Length(s) do begin
    if pos(s[n],seperators)<>0 then begin
      n1 := n;
      c := s[n];                          // take out Continues seperator
      while((n<=Length(s)) and (s[n]=c)) do inc(n);
      n2 := n;
      Break;
    end
    else  inc(n);
  end;
  result := Trim(copy(s,1,n1-1));
  delete(s,1,n2-1);
  if ((Result='') and (s<>'')) then begin
    s1 := s;
    s := Result;
    Result := s1;
  end;
end;

//**************************************************************
//     ƦW: VarStr
//     ت: N Variant নrB[ #39
//**************************************************************
function VarStr(const varPar: variant): string;
begin
  Result := VarToStr(varPar);
  if (VarType(varPar)=varNull) or (VarType(varPar)=varString) or
     (VarType(varPar)=varDate) then
    Result := #39 + Result + #39;
end;
function AddSlash(s:string):string;
begin
  if copy(s,length(s),1)<>'\' then result:=s+'\'
  else result:=s;
end;
end.
